

#include "defs.h"

#ifndef __IMAGER_IMBUF_H__
#define __IMAGER_IMBUF_H__



/* Allocate memory for image of dimensions x,y,z - returns a pointer (img)
   and an error code */

int allocate_image (image_type* img, TYPE_SELECTOR imgtype, int x, int y, int z);
int allocate_imgbuf (image_type* img, TYPE_SELECTOR imgtype, int x, int y, int z);

/* Duplicate an image */

int clone_image (image_type* src, image_type* dest);

/* Move an image buffer from src to dest */

void handback (image_type* dest, image_type* src);

/* Retrieve one data element from coordinates (x,y,z) */

void readbuf (image_type* img, void* element, int x, int y, int z);

/* Retrieve one element from coordinates (x,y,z) as float, char, rgb */

double readbuf_flt (image_type* img, int x, int y, int z);
unsigned char readbuf_char (image_type* img, int x, int y, int z);
rgbtriplet readbuf_rgb (image_type* img, int x, int y, int z);
double ireadbuf (image_type* img, double x, double y, int z, interpol_method intp);
rgbtriplet rgbireadbuf (image_type* img, double x, double y, int z, interpol_method intp);

/* Return whether an element has nonzero content (exact method) */

unsigned char nonzero (image_type* img, int x, int y, int z);

/* Store one data element at coords x,y,z */

void writebuf (image_type* img, void* element, int x, int y, int z);

/* Copy data between buffers of the same type */

void copybuf (image_type* src, image_type* dest, int x1, int y1, int z1, 
				int x2, int y2, int z2, long len);

/* Copy selected slices (a substack) between images of the same type.
   It is assumed that z1 of src becomes z=0 of dest */

void copybuf_z (image_type* src, image_type* dest, int z1, int z2);

/* Free data associated with this image */

void freebuf (image_type* img);

#endif
